(function ($, Drupal, window, document) {

  Drupal.behaviors.basic = {
    attach: function (context, settings) {

      var $lang_options_wrapper = $('[id^=edit-clone-lang-options]', context),
        $check_all = $lang_options_wrapper.find('span.check-all'),
        $uncheck_all = $lang_options_wrapper.find('span.uncheck-all');

      // Check all action.
      // Unbind all previously added listeners because
      // context contains entire form and as a result click listener will be
      // added as many times as ajax event happened.
      $check_all.unbind('click').on('click', function () {
        $lang_options_wrapper.find('.form-type-checkbox input').prop('checked', true)
      });

      // Uncheck all action. Same thing win unbinding here.
      $uncheck_all.unbind('click').on('click', function () {
        $lang_options_wrapper.find('.form-type-checkbox input').prop('checked', false)
      });

    }
  };

  /**
   * Behaviour updates clone languages list when user selects target language.
   */
  Drupal.behaviors.updateCloneLanguages = {
    attach: function (context, settings) {
      $('select[name="target_language"]', context).on('change', function() {
        $('input[name="update_clone_lang_options"]', context).trigger('click');
      });
    }
  };

}(jQuery, Drupal, this, this.document));
